'use strict';

var t = require('tap');
var A = require('../');
var Output = require('./output');

var arnie = A({
  providers: [Output()]
});

t.test('Provider: Output', function (t) {
  t.plan(2);

  arnie([function (_ref) {
    var output = _ref.output;

    return output({ test: 'path-not-defined' });
  }, function (_ref2) {
    var input = _ref2.input,
        output = _ref2.output;

    t.deepEqual(input, { test: 'path-not-defined' }, 'should return output when no matching path defined');
    return output({ test: 'path-defined' });
  }, {
    test: [function (_ref3) {
      var input = _ref3.input;

      t.deepEqual(input, { test: 'path-defined' }, 'should trigger path when defined');
    }]
  }]).catch(console.error);
});